-- Sets your player model and vanilla armor as invisible, while allowing held items to exist
vanilla_model.PLAYER:setVisible(false)
vanilla_model.HELD_ITEMS:setVisible(true)
vanilla_model.ARMOR:setVisible(false)

-- set your avatar blockbench model name.
local model = models.player_model

-- Controls camera positions. This controls both first and third person.
-- The blocks/entities you target will not match your crosshair while POV is turned on.
local pov = keybinds:newKeybind("POV Toggle", "key.keyboard.h")
povToggle = false
function pov:press()
  povToggle=not povToggle
  if povToggle then
    renderer:offsetCameraPivot(0, -0.7, 0)
  else
    renderer:offsetCameraPivot(0, 0, 0)
  end
end

-- Fixes crouching and GSit/Mount positions
function events.tick()
  local currentPose = player:getPose()
  if currentPose == "CROUCHING" then --Crouching Positions
      models.player_model:setPos(0, 4, 0)
      model.LEFT_LEG:setPos(0, -2, -1)
      model.RIGHT_LEG:setPos(0, -2, -1)
  elseif player:getVehicle() then --GSit/Mount Positions
      models.player_model:setPos(0, 4, 0)
      model.LEFT_LEG:setPos(defaultPos)
      model.RIGHT_LEG:setPos(defaultPos)
  else
      models.player_model:setPos(defaultPos)
      model.LEFT_LEG:setPos(defaultPos)
      model.RIGHT_LEG:setPos(defaultPos)
  end
end

-- Use speechBubble2 as a sent indicator
models.player_model.BODY.speechBubble2:setVisible(false)

function pings.messageSent()
  -- Animation contains scripts to set visibility true then false at the correct time
  animations.player_model.MessageSent:setPlaying(true)
end

function events.CHAT_SEND_MESSAGE(message)
  pings.messageSent()
  return message
end