--[[PagePoses.lua]]

-- Stops Pose animations when you move
function events.tick()
	if player:isSprinting() then
	  poseSit:setToggled(false)
	  animations.player_model.Sit:setPlaying(false)
	  poseLay:setToggled(false)
	  animations.player_model.Lay:setPlaying(false)
	  poseFaceplant:setToggled(false)
	  animations.player_model.Faceplant:setPlaying(false)
	  if povToggle then
		renderer:offsetCameraPivot(0, -0.6, 0)
	  else
		renderer:offsetCameraPivot(0, 0, 0)
	  end
	end
end

--import the `PageNavigation.lua` script into this script as `pageNav`.
local pageNav=require("lib.PageNavigation")
--create a new page
local PagePoses=action_wheel:newPage()
--add your actions to this page
  --Sit Emote
function pings.Sit(sit)
    animations.player_model.Sit:setPlaying(sit)
	poseLay:setToggled(false)
	animations.player_model.Lay:setPlaying(false)
	poseFaceplant:setToggled(false)
	animations.player_model.Faceplant:setPlaying(false)
	renderer:offsetCameraPivot(0, -0.8, 0)
	if sit == false then
		if povToggle then
			renderer:offsetCameraPivot(0, -0.6, 0)
		  else
			renderer:offsetCameraPivot(0, 0, 0)
		  end
	end
end
poseSit = PagePoses:newAction(2):title("Sit"):item("red_concrete"):color(171/255, 91/255, 79/255):onToggle(pings.Sit)
  --Lay Emote
function pings.Lay(lay)
    animations.player_model.Lay:setPlaying(lay)
	poseSit:setToggled(false)
	animations.player_model.Sit:setPlaying(false)
	poseFaceplant:setToggled(false)
	animations.player_model.Faceplant:setPlaying(false)
	renderer:offsetCameraPivot(0, -1.5, 0)
	if lay == false then
		if povToggle then
			renderer:offsetCameraPivot(0, -0.6, 0)
		  else
			renderer:offsetCameraPivot(0, 0, 0)
		  end
	end
end
poseLay = PagePoses:newAction(3):title("Lay"):item("orange_concrete"):color(227/255, 180/255, 93/255):onToggle(pings.Lay)
  --Wave Emote
function pings.playWave()
	animations.player_model.Point:stop()
    animations.player_model.Wave:play()
end
poseWave = PagePoses:newAction(4):title("Wave"):item("yellow_concrete"):color(227/255, 211/255, 93/255):onLeftClick(pings.playWave)
  --Point Emote
function pings.Point(point)
    animations.player_model.Point:setPlaying(point)
end
posePoint = PagePoses:newAction(5):title("Point"):item("lime_concrete"):color(147/255, 191/255, 113/255):onToggle(pings.Point)
  --Bow Emote
  function pings.playBow()
	animations.player_model.Faceplant:stop()
	poseFaceplant:setToggled(false)
	animations.player_model.Lay:stop()
	poseLay:setToggled(false)
	animations.player_model.Point:stop()
	posePoint:setToggled(false)
    animations.player_model.Bow:play()
	if animations.player_model.Sit:isPlaying() then
		renderer:offsetCameraPivot(0, -0.8, 0)
	elseif povToggle then
		renderer:offsetCameraPivot(0, -0.6, 0)
	  	else
		renderer:offsetCameraPivot(0, 0, 0)
	end
end
poseBow = PagePoses:newAction(6):title("Bow"):item("light_blue_concrete"):color(113/255, 191/255, 190/255):onLeftClick(pings.playBow)
  --Faceplant Emote
function pings.Faceplant(faceplant)
	animations.player_model.Faceplant:setPlaying(faceplant)
	poseSit:setToggled(false)
	animations.player_model.Sit:setPlaying(false)
	poseLay:setToggled(false)
	animations.player_model.Lay:setPlaying(false)
	renderer:offsetCameraPivot(0, -1.5, 0)
	if faceplant == false then
		if povToggle then
			renderer:offsetCameraPivot(0, -0.6, 0)
		  else
			renderer:offsetCameraPivot(0, 0, 0)
		  end
	end
end
poseFaceplant = PagePoses:newAction(7):title("Faceplant"):item("blue_concrete"):color(113/255, 117/255, 191/255):onToggle(pings.Faceplant)
--since the intention of this page is to be a subpage for another page, add an action that calls the `navigateBack` function.
PagePoses:newAction(1):title("Go Back"):item("minecraft:arrow"):onLeftClick(pageNav.navigateBack)

--at this point, we have the page but to way to access it. This is why we shall return an action that will take us to this page for another script to import.
return action_wheel:newAction()
  :title("Poses")
  :item("armor_stand")
  :onLeftClick(function()
    pageNav.navigatePage(PagePoses)
  end)